#ifndef LED_H_
#define LED_H_
//*****************************************************************************
//
// If building with a C++ compiler, make all of the definitions in this header
// have a C binding.
//
//*****************************************************************************
#ifdef __cplusplus
extern "C"
{
#endif
#define CPU_F ((double)48000000)
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))

extern int GSdata[48];

extern void LED_Set(int Num,int GS_Red,int GS_Green,int GS_Blue);

extern void Gradient();

extern void Scan();

extern void Smile();

extern void Flower();

extern void Doraemon();

extern void RainBow();

extern void Breathing();

extern void Word();

extern void Pulse();

//*****************************************************************************
//
// Mark the end of the C bindings section for C++ compilers.
//
//*****************************************************************************
#ifdef __cplusplus
}
#endif

//*****************************************************************************
//
// Close the Doxygen group.
//! @}
//
//*****************************************************************************
#endif /* LED_H_ */
