/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
/******************************************************************************
 * MSP432 Empty Project
 *
 * Description: An empty project that uses DriverLib
 *
 *                MSP432P401
 *             ------------------
 *         /|\|                  |
 *          | |                  |
 *          --|RST               |
 *            |                  |
 *            |                  |
 *            |                  |
 *            |                  |
 *            |                  |
 * Author: 
 *******************************************************************************/
/* DriverLib Includes */
#include <ti/devices/msp432p4xx/driverlib/driverlib.h>


/* Standard Includes */
#include <stdint.h>
#include <stdbool.h>
#include "TLC5957.H"
#include "LED.h"

/*#define CPU_F ((double)48000000)
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))
#define TIMER_PERIOD    1024*/
unsigned char line;
unsigned char key_flag=1;
/* Timer_A UpMode Configuration Parameter
const Timer_A_UpModeConfig upConfig =
{
        TIMER_A_CLOCKSOURCE_SMCLK,              // SMCLK Clock Source
        TIMER_A_CLOCKSOURCE_DIVIDER_1,          // SMCLK/1 = 3MHz
        TIMER_PERIOD,                           // 5000 tick period
        TIMER_A_TAIE_INTERRUPT_DISABLE,         // Disable Timer interrupt
        TIMER_A_CCIE_CCR0_INTERRUPT_ENABLE ,    // Enable CCR0 interrupt
        TIMER_A_DO_CLEAR                        // Clear value
};*/

int GSdata0[]={
               0x0000,0x0000,0x0000,   //D0B, D7G, D0R
               0x0000,0x0000,0x0000,   //D1B, D6G, D1R
               0x0000,0x0000,0x0000,   //D2B, D5G, D2R
               0x0000,0x0000,0x0000,   //D3B, D4G, D3R
               0x0000,0x0000,0x0000,   //D4B, D3G, D4R
               0x0000,0x0000,0x0000,   //D5B, D2G, D5R
               0x0000,0x0000,0x0000,   //D6B, D1G, D6R
               0x0000,0x0000,0x0000,   //D7B, D0G, D7R
               0x0000,0x0000,0x0000,   //D8B, D15G, D8R
               0x0000,0x0000,0x0000,   //D9B, D14G, D9R
               0x0000,0x0000,0x0000,   //D10B, D13G, D10R
               0x0000,0x0000,0x0000,   //D11B, D12G, D11R
               0x0000,0x0000,0x0000,   //D12B, D11G, D12R
               0x0000,0x0000,0x0000,   //D13B, D10G, D13R
               0x0000,0x0000,0x0000,   //D14B, D9G, D14R
               0x0000,0x0000,0x0000    //D15B, D8G, D15R
};

int GSdata1[]={
               4,4,4,   //D0 B,G,R
               4,4,4,   //D1 B,G,R
               4,4,4,   //D2 B,G,R
               4,4,4,   //D3 B,G,R
               4,4,4,   //D4 B,G,R
               4,4,4,   //D5 B,G,R
               4,4,4,   //D6 B,G,R
               4,4,4,   //D7 B,G,R
               4,4,4,   //D8 B,G,R
               4,4,4,   //D9 B,G,R
               4,4,4,   //D10 B,G,R
               4,4,4,   //D11 B,G,R
               4,4,4,   //D12 B,G,R
               4,4,4,   //D13 B,G,R
               4,4,4,   //D14 B,G,R
               4,4,4,   //D15 B,G,R
};

int GSdataR[]={
               0x000,0x000,0xfff,   //D0B, D7G, D0R
               0x000,0x000,0xfff,   //D1B, D6G, D1R
               0x000,0x000,0xfff,   //D2B, D5G, D2R
               0x000,0x000,0xfff,   //D3B, D4G, D3R
               0x000,0x000,0xfff,   //D4B, D3G, D4R
               0x000,0x000,0xfff,   //D5B, D2G, D5R
               0x000,0x000,0xfff,   //D6B, D1G, D6R
               0x000,0x000,0xfff,   //D7B, D0G, D7R
               0x000,0x000,0xfff,   //D8B, D15G, D8R
               0x000,0x000,0xfff,   //D9B, D14G, D9R
               0x000,0x000,0xfff,   //D10B, D13G, D10R
               0x000,0x000,0xfff,   //D11B, D12G, D11R
               0x000,0x000,0xfff,   //D12B, D11G, D12R
               0x000,0x000,0xfff,   //D13B, D10G, D13R
               0x000,0x000,0xfff,   //D14B, D9G, D14R
               0x000,0x000,0xfff    //D15B, D8G, D15R
};

int GSdataG[]={
               0x000,0xfff,0x000,   //D0B, D7G, D0R
               0x000,0xfff,0x000,   //D1B, D6G, D1R
               0x000,0xfff,0x000,   //D2B, D5G, D2R
               0x000,0xfff,0x000,   //D3B, D4G, D3R
               0x000,0xfff,0x000,   //D4B, D3G, D4R
               0x000,0xfff,0x000,   //D5B, D2G, D5R
               0x000,0xfff,0x000,   //D6B, D1G, D6R
               0x000,0xfff,0x000,   //D7B, D0G, D7R
               0x000,0xfff,0x000,   //D8B, D15G, D8R
               0x000,0xfff,0x000,   //D9B, D14G, D9R
               0x000,0xfff,0x000,   //D10B, D13G, D10R
               0x000,0xfff,0x000,   //D11B, D12G, D11R
               0x000,0xfff,0x000,   //D12B, D11G, D12R
               0x000,0xfff,0x000,   //D13B, D10G, D13R
               0x000,0xfff,0x000,   //D14B, D9G, D14R
               0x000,0xfff,0x000    //D15B, D8G, D15R
};

int GSdataB[]={
               0xfff,0x000,0x000,   //D0B, D7G, D0R
               0xfff,0x000,0x000,   //D1B, D6G, D1R
               0xfff,0x000,0x000,   //D2B, D5G, D2R
               0xfff,0x000,0x000,   //D3B, D4G, D3R
               0xfff,0x000,0x000,   //D4B, D3G, D4R
               0xfff,0x000,0x000,   //D5B, D2G, D5R
               0xfff,0x000,0x000,   //D6B, D1G, D6R
               0xfff,0x000,0x000,   //D7B, D0G, D7R
               0xfff,0x000,0x000,   //D8B, D15G, D8R
               0xfff,0x000,0x000,   //D9B, D14G, D9R
               0xfff,0x000,0x000,   //D10B, D13G, D10R
               0xfff,0x000,0x000,   //D11B, D12G, D11R
               0xfff,0x000,0x000,   //D12B, D11G, D12R
               0xfff,0x000,0x000,   //D13B, D10G, D13R
               0xfff,0x000,0x000,   //D14B, D9G, D14R
               0xfff,0x000,0x000    //D15B, D8G, D15R
};

int GSdataP[]={
               0xfff,0x000,0xfff,   //D0B, D7G, D0R
               0xfff,0x000,0xfff,   //D1B, D6G, D1R
               0xfff,0x000,0xfff,   //D2B, D5G, D2R
               0xfff,0x000,0xfff,   //D3B, D4G, D3R
               0xfff,0x000,0xfff,   //D4B, D3G, D4R
               0xfff,0x000,0xfff,   //D5B, D2G, D5R
               0xfff,0x000,0xfff,   //D6B, D1G, D6R
               0xfff,0x000,0xfff,   //D7B, D0G, D7R
               0xfff,0x000,0xfff,   //D8B, D15G, D8R
               0xfff,0x000,0xfff,   //D9B, D14G, D9R
               0xfff,0x000,0xfff,   //D10B, D13G, D10R
               0xfff,0x000,0xfff,   //D11B, D12G, D11R
               0xfff,0x000,0xfff,   //D12B, D11G, D12R
               0xfff,0x000,0xfff,   //D13B, D10G, D13R
               0xfff,0x000,0xfff,   //D14B, D9G, D14R
               0xfff,0x000,0xfff    //D15B, D8G, D15R
};

int GSdataY[]={
               0x000,0xfff,0xfff,   //D0B, D7G, D0R
               0x000,0xfff,0xfff,   //D1B, D6G, D1R
               0x000,0xfff,0xfff,   //D2B, D5G, D2R
               0x000,0xfff,0xfff,   //D3B, D4G, D3R
               0x000,0xfff,0xfff,   //D4B, D3G, D4R
               0x000,0xfff,0xfff,   //D5B, D2G, D5R
               0x000,0xfff,0xfff,   //D6B, D1G, D6R
               0x000,0xfff,0xfff,   //D7B, D0G, D7R
               0x000,0xfff,0xfff,   //D8B, D15G, D8R
               0x000,0xfff,0xfff,   //D9B, D14G, D9R
               0x000,0xfff,0xfff,   //D10B, D13G, D10R
               0x000,0xfff,0xfff,   //D11B, D12G, D11R
               0x000,0xfff,0xfff,   //D12B, D11G, D12R
               0x000,0xfff,0xfff,   //D13B, D10G, D13R
               0x000,0xfff,0xfff,   //D14B, D9G, D14R
               0x000,0xfff,0xfff    //D15B, D8G, D15R
};

int GSdataT[]={
               0xfff,0xfff,0x000,   //D0B, D7G, D0R
               0xfff,0xfff,0x000,   //D1B, D6G, D1R
               0xfff,0xfff,0x000,   //D2B, D5G, D2R
               0xfff,0xfff,0x000,   //D3B, D4G, D3R
               0xfff,0xfff,0x000,   //D4B, D3G, D4R
               0xfff,0xfff,0x000,   //D5B, D2G, D5R
               0xfff,0xfff,0x000,   //D6B, D1G, D6R
               0xfff,0xfff,0x000,   //D7B, D0G, D7R
               0xfff,0xfff,0x000,   //D8B, D15G, D8R
               0xfff,0xfff,0x000,   //D9B, D14G, D9R
               0xfff,0xfff,0x000,   //D10B, D13G, D10R
               0xfff,0xfff,0x000,   //D11B, D12G, D11R
               0xfff,0xfff,0x000,   //D12B, D11G, D12R
               0xfff,0xfff,0x000,   //D13B, D10G, D13R
               0xfff,0xfff,0x000,   //D14B, D9G, D14R
               0xfff,0xfff,0x000    //D15B, D8G, D15R
};

void Switch_Line(unsigned char i)
{
    switch(i)
    {
    case 1:
    {GPIO_setOutputHighOnPin(GPIO_PORT_P2, GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    } break;
    case 2:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P2, GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    } ;break;
    case 3:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P2, GPIO_PIN4);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    } ;break;
    case 4:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P5, GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    } ;break;
    case 5:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P6, GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN7);
    } ;break;
    case 6:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P6, GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6);
    } ;break;
    case 7:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P2,GPIO_PIN3);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    } ;break;
    case 8:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN1);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    } ;break;
    case 9:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    } ;break;
    case 10:
    { GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    };break;
    }
}

void Switch_Line_Off(unsigned char i)
{
    switch(i)
    {
    case 1:
    {GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN7);
    } break;
    case 2:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN6);
    } ;break;
    case 3:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN4);
    } ;break;
    case 4:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P5, GPIO_PIN6);
    } ;break;
    case 5:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P6, GPIO_PIN6);
    } ;break;
    case 6:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P6, GPIO_PIN7);
    } ;break;
    case 7:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P2,GPIO_PIN3);
    } ;break;
    case 8:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN1);
    } ;break;
    case 9:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5);
    } ;break;
    case 10:
    { GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN7);
    };break;
    }
}

void  Init_Line()
{
    GPIO_setAsOutputPin(GPIO_PORT_P1,GPIO_PIN6|GPIO_PIN7);
    GPIO_setAsOutputPin(GPIO_PORT_P2,GPIO_PIN3|GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setAsOutputPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN6|GPIO_PIN7);
    GPIO_setAsOutputPin(GPIO_PORT_P5,GPIO_PIN0|GPIO_PIN1|GPIO_PIN2|GPIO_PIN6|GPIO_PIN7);
    GPIO_setAsOutputPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputHighOnPin(GPIO_PORT_P1,GPIO_PIN6|GPIO_PIN7); // GPIO_setOutputHighOnPin(GPIO_PORT_P1,GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputHighOnPin(GPIO_PORT_P2, GPIO_PIN3|GPIO_PIN4|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN0|GPIO_PIN1|GPIO_PIN2|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputHighOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
}

int main(void)
{
    /*Main code for TLC5957 Matrix*/
    Init_Clock();
    Init_TLC5957();
    Init_Line();

    /* Configuring P1.1 as an input and enabling interrupts */
    MAP_GPIO_setAsInputPinWithPullUpResistor(GPIO_PORT_P1, GPIO_PIN1);
    MAP_GPIO_clearInterruptFlag(GPIO_PORT_P1, GPIO_PIN1);
    MAP_GPIO_enableInterrupt(GPIO_PORT_P1, GPIO_PIN1);
    MAP_Interrupt_enableInterrupt(INT_PORT1);

    /* Enabling SRAM Bank Retention */
    MAP_SysCtl_enableSRAMBankRetention(SYSCTL_SRAM_BANK1);

    /* Enabling MASTER interrupts */
    MAP_Interrupt_enableMaster();

    GPIO_setOutputLowOnPin(GPIO_PORT_P2, GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P1,GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P2,GPIO_PIN3|GPIO_PIN4|GPIO_PIN6);
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN0|GPIO_PIN1|GPIO_PIN2|GPIO_PIN6|GPIO_PIN7);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN6|GPIO_PIN7);
    GPIO_setAsPeripheralModuleFunctionOutputPin(GPIO_PORT_P4,GPIO_PIN3,GPIO_PRIMARY_MODULE_FUNCTION);

    /* WriteFCData(char LGSE2,char Poker,char BC,char CCR,char CCB, char CCG,char LGSE1, char SEL_SCK_EDGE,char LGSE3,char ESPWM, char SEL_PCHG,char SEL_GCK_EDGE,
                                       char XREFRFSH, char SEL_GDLY, char SEL_TD0, char LODVTH);*/
    //Switch_Line(2);
    WriteFCData(0,1,2,256,256,256,0,0,0,1,0,0,1,0,0,0);//Write FC data first
    //WriteGSData_Poker(GSdata1);
    //Doraemon();//Run Doraemon
    //Scan();
    //Smile();
    //Gradient();
    //RainBow();
    //Flower();
    //Breathing();
    /*while(1)
    {
        WriteGSData(GSdata1);
        delay_ms(1);
    }*/

    //Switch_Line(3);
    //WriteGSData_Poker(GSdata1);

    while(1)
    {
     switch (key_flag)
       {
       case 1: Scan();break;

       case 2: Smile();break;

       case 3: Gradient();break;

       case 4: Flower();break;

       case 5: Doraemon();break;

       case 6: Word();break;

       case 7: RainBow();break;

       case 8: Pulse();break;

       }
    }
}



/*void TA1_0_IRQHandler(void)
{
    GCLK(0);
    Switch_Line(line);
    WriteGSData(GSdata);
    GCLK(1);
    MAP_Timer_A_startCounter(TIMER_A1_BASE, TIMER_A_UP_MODE);
    MAP_Timer_A_clearCaptureCompareInterrupt(TIMER_A1_BASE,
            TIMER_A_CAPTURECOMPARE_REGISTER_0);


    //MAP_GPIO_toggleOutputOnPin(GPIO_PORT_P1, GPIO_PIN0);

}*/

/* GPIO ISR */
void PORT1_IRQHandler(void)// LED Ring effects switch function
{
    uint32_t status;

    status = MAP_GPIO_getEnabledInterruptStatus(GPIO_PORT_P1);
    MAP_GPIO_clearInterruptFlag(GPIO_PORT_P1, status);
    key_flag++;
    if(key_flag==9) key_flag=1;
}
